% CE for discrete problem
% update p_k directely
function [samples, Hbar, xbar] = MRAS_dis(N, K, choices, M)
% N: # of samples
% K: # of iterations
% choices: choice of test function
% M: dimension of the test function

%gamma_k=1;  %stepsize
%alpha=1.002;  % sample size increasing parameter
D=41;  %number of discrete points at 1 dim
dist=0.5;  %distance between points
st=-10;  %start point
p_k = 1/D*ones(1,M*D);  
X_k_indx=multirnd1(p_k,M,N);
X_k=st+(X_k_indx-1)*dist;

stop=0;
k=1;
samples=zeros(K,1);
Hbar = zeros(K,1);
xbar = zeros(K,M);
Ntotal=0;


while (stop==0)&&(k<=K)
    v=0.1;
    Ntotal=Ntotal+N;
    samples(k) = Ntotal;
  
    switch choices
        case 1
            Hl=0;
            G=-rosenbrock(X_k)+Hl;
        case 2
            Hl=0;
            G =-tri(X_k)+Hl;
        case 3
            Hl=0;
            G=-griewank(X_k)+Hl;
        case 4
            Hl=0;
            G=shekel(X_k)+Hl;
        case 5
            Hl=0;
            G=-dejong5(X_k)+Hl;
        case 6
            Hl=0;
            G=-powel(X_k)+Hl;
        case 7
            Hl=0;
            G=-levy(X_k)+Hl;
        case 8 
            Hl=0;
            G=-rastrigin(X_k)+Hl;
        case 9
            Hl=0;
            G = -pinter(X_k)+Hl;
        case 10
            Hl=0;
            G = -sphere(X_k)+Hl;
    end  % end switch
    [Hbar(k), indx] = max(G);
    xbar(k,:) = X_k(indx,:);

    if isnan(Hbar(k))==1  
        Hbar(k)=Hbar(k-1);
        xbar(k,:) =xbar(k-1,:);
        break
    end

    if k>2
    if Hbar(k-1)>max(G)     
        Hbar(k)=Hbar(k-1);
        xbar(k,:) =xbar(k-1,:);
    end 
    end
    Hbar(k)=Hbar(k)-Hl;
    %r=1e-4;
    %r=((1e-3)+abs(1*Hbar(k))/log(k))^(-1);
    for j=1:M
    IndX_k(:,(j-1)*D+1:j*D)=(X_k_indx(:,j)*ones(1,D)==([1:D]'*ones(1,N))');
    end
    %--use shape function---take the elite samples---
    rho=0.1;
    [G_sort, I_sort] = sort(G,'descend');   % sorted performances
    gm = G_sort(ceil(N*rho));
    
    f_k=prod((ones(N,1)*p_k).^IndX_k,2);
    f_k=f_k/max(f_k)+1e-5;
    
    r=1e-8;
    G_u=(G>=gm).*exp(r*G);
    G_u=G_u/max(G_u);
    G_u=G_u.^(k-1)./f_k;
    w_k=(G_u)/sum(G_u);


p_new=w_k'*IndX_k;
% for j=1:M
%     p_k_sum(j)=sum(p_new((j-1)*D+1:j*D));
% end
% p_k_sum
p_k=v*p_new+(1-v)*p_k;
    
%N=max(100,floor(k^0.502));
    X_k_indx=multirnd1(p_k,M,N);
    X_k=st+(X_k_indx-1)*dist;   
    k=k+1;    
    %N=N*alpha;
    %N=ceil(max(1000,(3/(2*10^5)*1/(1/k^1.5-1/(k+1)^1.5))^2));
    clear G G_u w_k grad_k IndX_k;
end %end while
for l=k:K
samples(l) = Ntotal;
Hbar(l)=Hbar(k-1);
xbar(l,:) =xbar(k-1,:);
Ntotal=Ntotal+N;
end